###############################################################
### Functions used for computation of prediction intervals, Section 6.2
### Vencalek, Hron, Filzmoser

# psti... transforms parameters of the model into probabilities
# gener ... generates 1 realisation from multinomial observation
# pred.interval.glm ... computes prediction interval for the GLM model

################################################################

psti = function(parameters)
{
  v5 = as.numeric(parameters) 
  r1 = exp(v5[1]+v5[3]*v5[5])
  r2 = exp(v5[2]+v5[4]*v5[5])
  denominator = r1*r2+r2+1
  pro = c(r1*r2,r2,1)/denominator
  return(pro)
}


gener = function(pst)
{
  vek = rmultinom(1, oN, pst)
  return(vek)
}


pred.interval.glm = function(model)
{
  mu = coef(model)
  S  = vcov(model)
  param = mvrnorm(N,mu,S)
  param = data.frame(param,rep(LengthTraining,N))
  prob = t(apply(param,1,psti))
  gen.data = apply(prob,1,gener)
  z1.gen = log(gen.data[1,]/gen.data[2,])
  z2.gen = log(gen.data[2,]/gen.data[3,])
  
  ip.z1 = quantile(z1.gen,c(0.025,0.975))
  ip.z2 = quantile(z2.gen,c(0.025,0.975))
  return(list(ip.z1=ip.z1,ip.z2=ip.z2))
}
