### study of variances and correlations
### auxiliary script

##########################################################################

### derived parameters and auxiliary variables:  
  di = 10
  x = 0:di

### theoretical probabilities corresponding to the parameters above:  
  pi1 = 1/(1+exp(-a1-b1*x)+exp(-a1-a2-(b1+b2)*x))
  pi2 = exp(-a1-b1*x)/(1+exp(-a1-b1*x)+exp(-a1-a2-(b1+b2)*x))
  pi3 = exp(-a1-a2-(b1+b2)*x)/(1+exp(-a1-b1*x)+exp(-a1-a2-(b1+b2)*x))
  P=cbind(pi1,pi2,pi3)
  print(P)

### variances and correlations:
  v1 = 1/P[,1]+1/P[,2]       # variances for z1
  v2 = 1/P[,2]+1/P[,3]       # variances for z2
  kov  = -1/P[,1]            # covariance between z1 and z2
  kor = kov/sqrt(v1*v2)      # correlation between z1 and z2

  print(round(cbind(v1,v2,kor),2))


